$(function(){

    console.info('The subscription widget has been loaded');

    var SUBSCRIPTION_TYPE_INDIVIDUAL = "INDIVIDUAL";
    var SUBSCRIPTION_TYPE_ENTERPRISE =  "ENTERPRISE";
    var APPLICATION = "DefaultApplication";
    var TIER = "Unlimited";

    var APP_NAME_FIELD='#subsAppName';
    var TIER_FIELD='#subsAppTier';
    var API_SUBSCRIPTION_URL = caramel.context + '/resources/webapp/v1/subscription/app';
    var API_UNSUBSCRIPTION_URL = caramel.context + '/resources/webapp/v1/unsubscription/app';
    var API_SUBSCRIPTION_WORKFLOW = caramel.context + '/resources/webapp/v1/subscription-workflow/app';
    var API_ADD_TO_FAVOURITE = caramel.context + '/apis/favourite/add-favourite-app';
    var API_REMOVE_FROM_FAVOURITE = caramel.context + '/apis/favourite/remove-favourite-app';

    var storeTenantDomain = $('#store-tenant-domain').val();
    var appName = $('#metadata-app-name').val();
    var appVersion = $('#metadata-app-version').val();
    var appProvider = $('#metadata-app-provider').val();

    $('#btnSubscribe').on('click',function(){
        if( $(this).attr("disabled") != 'disabled'){
            $(this).attr("disabled", true);
            selfSubScribe();
        }else{
            location.reload();
        }

    });
    
    // TODO : This code silently fails when enterprise subscriptions are not allowed. Handle it nicely.
    $('.enterpriseSubscriptions').popover({
      html:true,
      placement: 'bottom',
      trigger: 'click',
      content:$('#enterpriseSubscriptionManagementPanel').html()
    });

    $(document).on('click', '#btnSaveEnterpriseSubscriptions', function(){
      saveEnterpriseSubscriptions();
    });

    $('#btnUnsubscribe').on('click',function(){
    	 unSubscribe();
    });

    var selfSubScribe = function () {
        var subscription = {};
        subscription['apiName'] = appName;
        subscription['apiVersion'] = appVersion;
        subscription['apiProvider'] = appProvider;
        subscription['apiTier'] = TIER;
        subscription['subscriptionType'] = SUBSCRIPTION_TYPE_INDIVIDUAL;
        subscription['appName'] = APPLICATION;
        subscribeToApp(subscription);
    };
    
    var saveEnterpriseSubscriptions = function(){
      var subscribedEnterprises = getEnterpriseSubscriptionsFromUI();
      doSaveEnterpriseSubscriptions(subscribedEnterprises);
    }

    var getEnterpriseSubscriptionsFromUI = function(){

      var subscribedEnterprises = new Array();

      $('.popover-content .enterprise-entry').each(function( index ) {
        var checkbox = $(this).find("input:checkbox");
        var isSubscribed = $(this).find("input:checkbox")[0].checked;

        if(isSubscribed){
          var enterpriseName = $( this ).text();
          subscribedEnterprises.push(enterpriseName);  
        }
      });

      return subscribedEnterprises;

    };

    var doSaveEnterpriseSubscriptions = function(subscribedEnterprises){
        var subscription={};
        subscription['apiName'] = appName;
        subscription['apiVersion'] = appVersion;
        subscription['apiTier']=getTier();
        subscription['subscriptionType'] = SUBSCRIPTION_TYPE_ENTERPRISE;
        subscription['apiProvider'] = appProvider;
        subscription['appName'] = APPLICATION;
        subscription['enterprises'] = JSON.stringify(subscribedEnterprises);
        subscribeToApp(subscription);
    };

    var unSubscribe = function () {
        var subscription = {};
        subscription['apiName'] = appName;
        subscription['apiVersion'] = appVersion;
        subscription['apiProvider'] = appProvider;
        subscription['apiTier'] = TIER;
        subscription['appName'] = APPLICATION;
        unsubscribeToApp(subscription);
    };
    

    var getAppName=function(){
       return $(APP_NAME_FIELD)?$(APP_NAME_FIELD).val():'';
    };

    var getTier=function(){
       return $(TIER_FIELD)?$(TIER_FIELD).val():'';
    };

    /*
    The method invokes the API call which will subscribe the provided application to the given api
     */
    var subscribeToApp=function(subscription){
        $.ajax({
            url:API_SUBSCRIPTION_URL,
            dataType: 'JSON',
            type:'POST',
            data:subscription,
            complete: function(response, textStatus) {
                if(textStatus == "success") {
                    console.info('Successfully subscribed to Web app: ' + subscription.apiName);

                    // Update UI based on the subscription type.
                    if (subscription['subscriptionType'] == "INDIVIDUAL") {

                        noty({
                            text : 'You have successfully subscribed to the <b>'  + subscription.apiName + '</b>',
                            'layout' : 'center',
                            'timeout': 1500,
                            'modal': true,
                            'onClose': function() {
                                location.reload();
                            }
                        });

                    } else if (subscription['subscriptionType'] == "ENTERPRISE") {
                        updateUIAfterEnterpriseSubscription(subscription);
                    }
                }else{
                    alert("response error true")
                    console.info('Error occured in subscribe to web app: '+subscription.apiName);
                }
            },
            error : function(response) {
                alert('Error occured in subscribe');

            },
            success : function(e){
                //location.reload();
            }
        });
    };
    
    var showIndividualSubscriptionSuccessfulMessage = function(apiName){
    	  $.ajax({
              url:API_SUBSCRIPTION_WORKFLOW,
              type:'POST',
              success:function(response){
           	   if(response.status == false){
           		showIndividualSubscriptionMessage(false,'Subscription Approval','your request to subscribe the application is awaiting administrator approval');
           	   }else if(response.status == true){
           		showIndividualSubscriptionMessage(true,'Subscription Successful','Congratulations! You have successfully subscribed to the ' +'<b>"' + apiName + '</b>"' );
           	   }else{
        		console.info('Error occured in subscribe to web app: ');
		   }
              },
              error : function(response) {
			alert('Error occured in subscribe');
	      }
           });
    	
    
    }
    
    var showIndividualSubscriptionMessage = function(status,messageTitle, messageBody){

    	$('#messageModal1').html($('#confirmation-data1').html());
    	$('#messageModal1 h3.modal-title').html((messageTitle));
    	$('#messageModal1 div.modal-body').html('\n\n'+ (messageBody)+'.');
    	$('#messageModal1 a.btn-other').html('OK');

    	$('#messageModal1').modal();
    	if(status){ 
    	  	$('#btnUnsubscribe').show();
          	$('#btnSubscribe').hide();
          	$('#subscribed').val(true);
    	} else{
		$('#btnSubscribe').attr("disabled", true); 
    	}
   
    }
    
    var updateUIAfterEnterpriseSubscription = function(subscription){
      
      $('.enterpriseSubscriptions').popover('hide');
      
      var subscribedEnterprises = JSON.parse(subscription.enterprises);

      // Create a set of subscribed enterprises.
      var subscribedEnterprisesSet = {};
      for(var i = 0; i < subscribedEnterprises.length; i++){
        subscribedEnterprisesSet[subscribedEnterprises[i]] = true;
      }      

      // Iterate throgh the check boxes and update them accordingly.
      var checkboxContainer = $('#enterpriseSubscriptionManagementPanel #enterprises');
      var checkboxes = checkboxContainer.find("input[id^='checkboxEnterprise_']");

      for(var i = 0; i < checkboxes.length; i++){
        var checkbox = checkboxes[i];

        // Update this checkbox accordingly.
        checkbox.checked = checkbox.name in subscribedEnterprisesSet 
        
      }
    }

    var unsubscribeToApp=function(subscription){

        $.ajax({
           url:API_UNSUBSCRIPTION_URL,
           type:'POST',
           data:subscription,
           success:function(response){
        	   if(response.error == false){
               	  	console.info('Successfully unsubscribed to web app: '+subscription.apiName);
                	//alert('Succsessfully unsubscribed to the '+subscription.apiName+' Web App.');

                   noty({
                       text : 'You have successfully unsubscribed from the <b>'  + subscription.apiName + '</b>',
                       'layout' : 'center',
                       'timeout': 1500,
                       'modal': true,
                       'onClose': function() {
                           location.reload();
                       }
                   });


              
              		$('#btnUnsubscribe').hide();
              		$('#btnSubscribe').show();
	            	$('#subscribed').val(false);
              
		   }else{
           		console.info('Error occured in unsubscribe to web app: '+subscription.apiName);
           	   }
        	   
           },
           error : function(response) {
   			alert('Error occured in unsubscribe');
   		  }
        });
    };

    $('#btnAddToFav').on('click', function () {
        if ($(this).attr("disabled") != 'disabled') {
            $(this).attr("disabled", true);
            addToMyFavourite();
        } else {
            location.reload();
        }
    });

    $('#btnRemoveFromFav').on('click', function () {
        removeFromMyFavourite();
    });

    var addToMyFavourite = function () {
            var data = {};
            data['name'] = appName;
            data['version'] = appVersion;
            data['provider'] = appProvider;
            data['storeTenantDomain'] = storeTenantDomain;
            addToFavourite(data);
    };

    var removeFromMyFavourite = function () {
        var data = {};
        data['name'] = appName;
        data['version'] = appVersion;
        data['provider'] = appProvider;
        data['storeTenantDomain'] = storeTenantDomain;
        removeFromFavourite(data);
    };

    var addToFavourite = function (data) {
        $.ajax({
                   url: API_ADD_TO_FAVOURITE,
                   dataType: 'JSON',
                   type: 'POST',
                   data: data,
                   success: function (response, textStatus, xhr) {
                       if (response.error == false) {
                           var message = 'You have successfully added  <b>' + data.name +
                                         '</b> to your favourite apps';
                           notifyAndReload(message);
                       } else {
                           var message = 'Error occured in while adding  application: ' + data.name +
                                         "to my favourite applications";
                           notify(message);
                       }
                   },
                   error: function (response) {
                       if (response.status == 401) {
                           var message = 'Your session has time out.Please login again';
                           notify(message);
                       } else {
                           var message = 'Error occured in while adding  application: ' + data.name +
                                         ' to my favourite applications';
                           notify(message);
                       }

                   }
               });
    };

    var removeFromFavourite = function (data) {
        $.ajax({
                   url: API_REMOVE_FROM_FAVOURITE,
                   type: 'POST',
                   data: data,
                   success: function (response, textStatus, xhr) {
                       if (response.error == false) {
                           var message = 'You have successfully removed  <b>' + data.name
                               + '</b> from your favourite apps';
                           notifyAndReload(message);
                           $('#btnRemoveFromFav').hide();
                           $('#btnAddToFav').show();

                       } else {
                           var message = 'Error occured  when remove application: ' + data.name
                               + ' from my favourite applications';
                           notify(message);
                       }

                   },
                   error: function (response) {
                       if (response.status == 401) {
                           var message = 'Your session has time out.Please login again';
                           notify(message);
                       } else {
                           var message = 'Error occured  when remove application: ' + data.name
                               + ' from my favourite applications';
                           notify(message);
                       }
                   }
               });
    };

    var notify = function (message) {
        noty({
                 text: message,
                 'layout': 'center',
                 'timeout': 1500,
                 'modal': true
             });
    };

    var notifyAndReload = function (message) {
        noty({
                 text: message,
                 'layout': 'center',
                 'timeout': 1500,
                 'modal': true,
                 'onClose': function () {
                     location.reload();
                 }
             });
    };
  
});